// Package rate_limit ...
//
// Description : rate_limit ...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 2024-06-20 18:01
package rate_limit

import (
	"context"
	"fmt"
	"git.zhangdeman.cn/zhangdeman/rate_limit/define"
	wrapRedis "git.zhangdeman.cn/zhangdeman/redis"
	wrapRedisDefine "git.zhangdeman.cn/zhangdeman/redis/define"
	"testing"
	"time"
)

func TestRedis_AllowN(t *testing.T) {
	_ = wrapRedis.Client.AddClient("test_rate_limit", &wrapRedisDefine.Options{
		Addr:     "127.0.0.1:6379",
		Password: "123456",
		DB:       6,
	})
	RedisClient.SetRedisClient(wrapRedis.Client.GetRealClient("test_rate_limit"))
	for i := 0; i < 1000; i++ {
		allow, err := RedisClient.AllowN(context.Background(), &define.LimitConfig{
			Key:          "deman",
			Total:        60,
			Rate:         10,
			TimeInterval: 60,
		}, 8)
		fmt.Println(allow, err)
		time.Sleep(time.Second)
	}
}
